
// ----------------------------------------------------------------------

void drawCOMMsg() {
  // put text in COM value field
  if (comFlag < 1) {TR = 255;}
  drawTxtField(msgCOM, 68, 247); TR = 0;
}

// ----------------------------------------------------------------------

void drawDitherON() {
  // draw lamp based on servoON
  strokeWeight(3); noFill();
  if (dither0 == 1) {stroke(255,0,0); rect(628,116,24,24);}
  if (dither0 == 2) {stroke(0,0,255); rect(628,116,24,24);}
  if (dither1 == 1) {stroke(255,0,0); rect(208,66,25,23);}
  if (dither1 == 2) {stroke(0,0,255); rect(208,66,25,23);}
  if (dither2 == 1) {stroke(255,0,0); rect(541,66,25,23);}
  if (dither2 == 2) {stroke(0,0,255); rect(541,66,25,23);}
  if (dither3 == 1) {stroke(255,0,0); rect(295,116,24,24);}
  if (dither3 == 2) {stroke(0,0,255); rect(295,116,24,24);}
}

// ----------------------------------------------------------------------

void drawHelpMsg() {
  // put text in ? Help field
  TB = 255; drawTxtField(msgHelp, 68, 280); TB = 0;
}

// ----------------------------------------------------------------------

void drawLamps() {
  // draw lamps based on flags
  fill(20,210,0); stroke(0,0,0); strokeWeight(1); // green
  if (angleMode < 1) {
    rect(649,69,9,29);
  } else {
    rect(649,109,9,29);
  }
  fill(255,50,0); // red
 }

// ----------------------------------------------------------------------

void drawLLMsg() {
  // put text in LL value field
  drawTxtField(str(servo0LL), 600, 150); TR = 0; //
  drawTxtField(str(servo1LL), 154, 188); TR = 0;
  drawTxtField(str(servo2LL), 486, 188); TR = 0;
  drawTxtField(str(servo3LL), 268, 150); TR = 0; //
}

// ----------------------------------------------------------------------

void drawMEM() {
  // draws the MEM button lamp if something is stored
  if (MEM) {
    stroke(100,255,100); fill(100,255,100); rect(575,203,6,20);
    stroke(0,0,0);
  }
}

// ----------------------------------------------------------------------

void drawMouseXY() {
  // draws the value of mouse x,y top left
  // draws a full X/Y axis on the form
  if ((mX != mXL) || (mY != mYL)) {
    // draw full X/Y axis
    stroke(255,0,0,128); strokeWeight(1);
    line(0,mY,671,mY); line(mX,0,mX,319);

    int zX,zY;
    if (mX > 340) {zX = mX - 58;} else {zX = mX + 8;}
    if (mY > 160) {zY = mY - 53;} else {zY = mY + 8;}
    stroke(0,0,0); fill(255,255,255); rect(zX,zY,50,45);
    fill(0,0,0);
    text("X=" + mX, zX + 4, zY + 13);
    text("Y=" + mY, zX + 4, zY + 27);
    text("K=" + keyVal, zX + 4, zY + 41);
    mXL = mX; mYL = mY;
  }
}

// ----------------------------------------------------------------------

void drawPingLamp() {
  // draws a ping lamp if the servo is ON
  if ((servoON > 0)  && (comFlag > 0)) {
    if (tick <= 3) {
      stroke(0,0,0); fill(255,0,0); rect(641,211,10,20);
    }
  }
}

// ----------------------------------------------------------------------

void drawRxMsg() {
  // put text in the Rx field
  anyStr = msgRx;
  if (anyStr.length() > 40) {anyStr = anyStr.substring(0,40) + "...";}
  drawTxtField(anyStr, 195, 247);
}

// ----------------------------------------------------------------------

void drawServoON() {
  // draw lamp based on servoON
  strokeWeight(3);
  if (servoON > 0) {
    // red
    stroke(255,0,0);
    line(336,49,387,49);
    line(387,49,387,89);
    line(336,89,387,89);
    line(336,49,336,89);
  } else {
    stroke(0,255,0);
    line(284,49,336,49);
    line(336,49,336,89);
    line(284,89,336,89);
    line(284,49,284,89);
  }
 }

// ----------------------------------------------------------------------

void drawSineON() {
  // draw box lamp based on sineN settings
  strokeWeight(3); stroke(255,0,0); noFill();
  if (sine0 == 1) {stroke(255,0,0); rect(603,116,24,24);}
  if (sine0 == 2) {stroke(0,0,255); rect(603,116,24,24);}
  if (sine1 == 1) {stroke(255,0,0); rect(208,88,25,23);}
  if (sine1 == 2) {stroke(0,0,255); rect(208,88,25,23);}
  if (sine2 == 1) {stroke(255,0,0); rect(541,88,25,23);}
  if (sine2 == 2) {stroke(0,0,255); rect(541,88,25,23);}
  if (sine3 == 1) {stroke(255,0,0); rect(271,116,24,24);}
  if (sine3 == 2) {stroke(0,0,255); rect(271,116,24,24);}
}

// ----------------------------------------------------------------------

void drawTxMsg() {
  // put text in Tx field
  drawTxtField(msgTx, 517, 247);
}

// ----------------------------------------------------------------------

void drawKeybrdTxt() {
  // if in kleyboard entry mode draw a box and display text
 cursor--; if (cursor < 1) {cursor = 50;}
  stroke(255,0,0); fill(0,0,0); rect(512,242,138,25);
  if (cursor > 25) {
    fill(255,255,255); text(keyBrdmsg + "|", 516, 258);
  } else {
    fill(255,255,255); text(keyBrdmsg, 516, 258);
  }
}

// ----------------------------------------------------------------------

void drawTxtField(String zM,int zX, int zY) {
//  stroke(242,242,242); fill(242,242,242); 
  noStroke(); noFill(); 
  rect(zX, zY, 8+textWidth(zM), 14);
  fill(TR,TG,TB); if (comFlag < 1) {fill(255,0,0);}
  text(zM, zX+4, zY+12);
}

// ----------------------------------------------------------------------

void drawULMsg() {
  // put text in UL value field
  drawTxtField(str(servo0UL), 372, 150); TR = 0; //
  drawTxtField(str(servo1UL), 154, 70); TR = 0;
  drawTxtField(str(servo2UL), 486, 70); TR = 0;
  drawTxtField(str(servo3UL), 38, 150); TR = 0; //
}

// ----------------------------------------------------------------------

void exit() {
  // program is closing so reset Arduino...
  usbPortWrite("!");
  delay(20); // allow 20ms for data to be sent
  super.exit();
}

// ----------------------------------------------------------------------

void endCOMPort() {
  // disconnect current COM port connection if connected
  if (comFlag > 0) {
    // stops an existing connection if already made
    usbPort.stop();
    comFlag = 0; msgCOM = "----"; delay(100); drawFlag = 1;
  }
}

// ----------------------------------------------------------------------

void getCOMPort() {
  // initialise serial comms if a port exists
  // this also resets this app, ignoring previous settings
  resetFlags();
  if (comFlag > 0) {
    // stops an existing connection if already made
    usbPort.stop();
    comFlag = 0; msgCOM = "----"; delay(100);
  }
  comListLength = Serial.list().length;
  if (comListLength > 0) {
    comPnt++; if (comPnt >= comListLength) {comPnt = 0;}
    // test available serial port
    comName = Serial.list()[comPnt];
    println(comName);
    try {
      usbPort = new Serial(this, comName, 115200);
      usbPort.bufferUntil(LF); comCnt = 500;
      comFlag = 1; msgCOM = comName;
    } catch(Exception e) {
      comFlag = 0; msgCOM = "-Error-";
    }
  } else {
    // no serial port available
    comFlag = 0; msgCOM = "-NA-";
  }
}

// ----------------------------------------------------------------------

void loadScrn(int zMode) {
  // load a background image
  if (zMode == 0) {img = loadImage("Control Pad.png");}
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void MEM_Recall() {
  // recall store servo values
  if (!MEM) return;
  
  usbPortWrite("RP0.");  // get the current servo values
  delay(20);
  boolean zMove = true;
  while (zMove == true) {
    zMove = false;
    if (servo0Val != MEM0) {
      if (servo0Val > (MEM0 + 4)) {servo0Val-= 4;}
      else if (servo0Val < (MEM0 - 4)){servo0Val+= 4;}
      else {servo0Val = MEM0;}
      msgTx  = "SN0.SV" + str(servo0Val) + ".";
      usbPortWrite(msgTx); zMove = true; delay(4);
    }
    if (servo1Val != MEM1) {
      if (servo1Val > (MEM1 + 4)) {servo1Val-= 4;}
      else if (servo1Val < (MEM1 - 4)){servo1Val+= 4;}
      else {servo1Val = MEM1;}
      msgTx  = "SN1.SV" + str(servo1Val) + ".";
      usbPortWrite(msgTx); zMove = true; delay(4);
    }
    if (servo2Val != MEM2) {
      if (servo2Val > (MEM2 + 4)) {servo2Val-= 4;}
      else if (servo2Val < (MEM2 - 4)){servo2Val+= 4;}
      else {servo2Val = MEM2;}
      msgTx  = "SN2.SV" + str(servo2Val) + ".";
      usbPortWrite(msgTx); zMove = true; delay(4);
    }
    if (servo3Val != MEM3) {
      if (servo3Val > (MEM3 + 4)) {servo3Val-= 4;}
      else if (servo3Val < (MEM3 - 4)){servo3Val+= 4;}
      else {servo3Val = MEM3;}
      msgTx  = "SN3.SV" + str(servo3Val) + ".";
      usbPortWrite(msgTx); zMove = true; delay(4);
    }
  }
}

// ----------------------------------------------------------------------

void MEM_Store() {
  // store servo values
  MEM0 = servo0Val;
  MEM1 = servo1Val;
  MEM2 = servo2Val;
  MEM3 = servo3Val;
  MEM = true; drawFlag = 1;
}

// ----------------------------------------------------------------------

void resetFlags() {
  // set flags to match RESET condition
  angleMode = 1; // 0 = degrees, 1 = microseconds
  comCnt = 0; // count down timer detects link disconnect
  dither0 = 0; // dither enabled flag for servo 0
  dither1 = 0; // dither enabled flag for servo 1
  dither2 = 0; // dither enabled flag for servo 2
  dither3 = 0; // dither enabled flag for servo 3
  drawFlag = 1; // = 1 to force screen redraw
  msgCh = "---"; // channel message sent to Arduino
  mTO = 0; // mouse down timeout
  period = 100; // half period in draw loop units
  period2 = period / 2; // quarter period in draw loop units
  phase = 0; // current waveform phase
  servoMin = 500; // limit constants for servo values
  servoMax = 2600; // limit constants for servo values
  servoMMD = servoMax - servoMin; // limit difference constant for servo values
  servoON = 0; // servos are OFF
  servoSwp = 0; // servo sweep flag; default = 0  OFF, 1 = ON
  servo0Val = 1500; // =90' servo middle value
  servo1Val = 1500; // =90' servo middle value
  servo2Val = 1900; // =90' servo middle value
  servo3Val = 1300; // =90' servo middle value
  servo0LL = servoMin; // =0' servo 0 LL value
  servo0UL = servoMax; // =180' servo 0 UL value
  servo1LL = servoMin; // =0' servo 1 LL value
  servo1UL = servoMax; // =180' servo 1 UL value
  servo2LL = servoMin; // =0' servo 2 LL value
  servo2UL = servoMax; // =180' servo 2 UL value
  servo3LL = servoMin; // =0' servo 3 LL value
  servo3UL = servoMax; // =180' servo 3 UL value
  sine0 = 0; // sine sweep enabled flag for servo 0
  sine1 = 0; // sine sweep enabled flag for servo 1
  sine2 = 0; // sine sweep enabled flag for servo 2
  sine3 = 0; // sine sweep enabled flag for servo 3
  timeCnt = 0; // wave count down timer
}

// ----------------------------------------------------------------------

void sendButton(String zS) {
  // called when a button is clicked on the scrn
  msgTx = zS; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void sendHomeCmd() {
  // send a goto Home position cmd to the arduinio
  dither0 = 0; dither1 = 0; dither2 = 0; dither3 = 0;
  sine0 = 0; sine1 = 0; sine2 = 0; sine3 = 0;
  msgTx = "HM."; usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void send0LL() {
  // send a lower limit msg to arduino
  msgTx = "SN0.SL" + str(servo0LL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send1LL() {
  // send a lower limit msg to arduino
  msgTx = "SN1.SL" + str(servo1LL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send2LL() {
  // send a lower limit msg to arduino
  msgTx = "SN2.SL" + str(servo2LL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send3LL() {
  // send a lower limit msg to arduino
  msgTx = "SN3.SL" + str(servo3LL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void sendRESET() {
  // reset defaults and send RESET msg to arduino
  resetFlags(); drawFlag = 1;
  msgTx = "!"; usbPortWrite(msgTx);
}

// ----------------------------------------------------------------------

void sendRPosCmd() {
  // send a goto RESET position cmd to the arduinio
  dither0 = 0; dither1 = 0; dither2 = 0; dither3 = 0;
  sine0 = 0; sine1 = 0; sine2 = 0; sine3 = 0;
  msgTx = "RM."; usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void send0UL() {
  // send an upper limit msg to arduino
  msgTx = "SN0.SU" + str(servo0UL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send1UL() {
  // send an upper limit msg to arduino
  msgTx = "SN1.SU" + str(servo1UL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send2UL() {
  // send an upper limit msg to arduino
  msgTx = "SN2.SU" + str(servo2UL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void send3UL() {
  // send an upper limit msg to arduino
  msgTx = "SN3.SU" + str(servo3UL) + "."; usbPortWrite(msgTx);
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void sendUSB(String zS) {
  // send a string directly to the USB port
  msgTx = zS; usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void sendVal(int zD, int zI) {
    // send the servo zD value to the arduino with offset zI
  switch (zD) {
    case 0: msgTx = "SN0.SV" + str(servo0Val + zI) + "."; break;
    case 1: msgTx = "SN1.SV" + str(servo1Val + zI) + "."; break;
    case 2: msgTx = "SN2.SV" + str(servo2Val + zI) + "."; break;
    case 3: msgTx = "SN3.SV" + str(servo3Val + zI) + "."; break;
  } usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void setDither(int zD) {
  // apply dither to the specified target servo
  // sync phase if starting or stopping
  int zRun = 0;
  switch(zD) {
    case 0:
      if ((dither0 == 1) || (dither0 == 3)) {zRun = 1;}
      if ((dither0 == 3) && (ditherPhase == 3)) {dither0 = 0;}
      else if ((dither0 == 2) && (ditherPhase == 0)) {dither0 = 1; zRun = 1;}
      break;
    case 1:
      if ((dither1 == 1) || (dither1 == 3)) {zRun = 1;}
      if ((dither1 == 3) && (ditherPhase == 3)) {dither1 = 0;}
      else if ((dither1 == 2) && (ditherPhase == 0)) {dither1 = 1; zRun = 1;}
      break;
    case 2:
      if ((dither2 == 1) || (dither2 == 3)) {zRun = 1;}
      if ((dither2 == 3) && (ditherPhase == 3)) {dither2 = 0;}
      else if ((dither2 == 2) && (ditherPhase == 0)) {dither2 = 1; zRun = 1;}
      break;
    case 3:
      if ((dither3 == 1) || (dither3 == 3)) {zRun = 1;}
      if ((dither3 == 3) && (ditherPhase == 3)) {dither3 = 0;}
      else if ((dither3 == 2) && (ditherPhase == 0)) {dither3 = 1; zRun = 1;}
      break;
  }
  // apply dither if zRun > 0
  if (zRun > 0) {
    switch(ditherPhase) {
      case 0: sendVal(zD,20); break;
      case 1: sendVal(zD,-20); break;
      case 2: sendVal(zD,-20); break;
      case 3: sendVal(zD,20); break;
    }
  }
}

// ----------------------------------------------------------------------

void set0LLToVal() {
  // sets the lower limit of servo 0 to its current value
  servo0LL = servo0Val;
  send0LL();
}

// ----------------------------------------------------------------------

void set1LLToVal() {
  // sets the lower limit of servo 1 to its current value
  servo1LL = servo1Val;
  send1LL();
}

// ----------------------------------------------------------------------

void set2LLToVal() {
  // sets the lower limit of servo 2 to its current value
  servo2LL = servo2Val;
  send2LL();
}

// ----------------------------------------------------------------------

void set3LLToVal() {
  // sets the lower limit of servo 3 to its current value
  servo3LL = servo3Val;
  send3LL();
}

// ----------------------------------------------------------------------

void set0LLValDwn() {
  // reduce the slider lower limit
  servo0LL = servo0LL - valInc;
  servo0LL = max(servoMin,servo0LL);
  send0LL();
}

// ----------------------------------------------------------------------

void set1LLValDwn() {
  // reduce the slider lower limit
  servo1LL = servo1LL - valInc;
  servo1LL = max(servoMin,servo1LL);
  send1LL();
}

// ----------------------------------------------------------------------

void set2LLValDwn() {
  // reduce the slider lower limit
  servo2LL = servo2LL - valInc;
  servo2LL = max(servoMin,servo2LL);
  send2LL();
}

// ----------------------------------------------------------------------

void set3LLValDwn() {
  // reduce the slider lower limit
  servo3LL = servo3LL - valInc;
  servo3LL = max(servoMin,servo3LL);
  send3LL();
}

// ----------------------------------------------------------------------

void set0LLValUp() {
  // increase the slider upper limit
  servo0LL = servo0LL + valInc;
  if (servo0LL > servo0UL) {servo0UL = servo0LL;}
  servo0LL = min(servoMax,servo0LL);
  servo0UL  = min(servoMax,servo0UL);
  send0LL();
}

// ----------------------------------------------------------------------

void set1LLValUp() {
  // increase the slider upper limit
  servo1LL = servo1LL + valInc;
  if (servo1LL > servo1UL) {servo1UL = servo1LL;}
  servo1LL = min(servoMax,servo1LL);
  servo1UL  = min(servoMax,servo1UL);
  send1LL();
}

// ----------------------------------------------------------------------

void set2LLValUp() {
  // increase the slider upper limit
  servo2LL = servo2LL + valInc;
  if (servo2LL > servo2UL) {servo2UL = servo2LL;}
  servo2LL = min(servoMax,servo2LL);
  servo2UL  = min(servoMax,servo2UL);
  send2LL();
}

// ----------------------------------------------------------------------

void set3LLValUp() {
  // increase the slider upper limit
  servo3LL = servo3LL + valInc;
  if (servo3LL > servo3UL) {servo3UL = servo3LL;}
  servo3LL = min(servoMax,servo3LL);
  servo3UL  = min(servoMax,servo3UL);
  send3LL();
}

// ----------------------------------------------------------------------

void setServoOFF() {
  // send a servo OFF message
  servoON = 0; msgTx = "KO."; usbPortWrite(msgTx);
  dither0 = 0; dither1 = 0; dither2 = 0; dither3 = 0;
  sine0 = 0; sine1 = 0; sine2 = 0; sine3 = 0;
  drawFlag = 1;
}

// ----------------------------------------------------------------------

void setServoON() {
  // send a servo ON message
  servoON = 1; msgTx = "KE."; usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void setSine(int zS) {
  // outputs a sinewave for the targetted servo
  switch(zS) {
    case 0:
      halfRnge = ((servo0UL) - servo0LL)/2.0; midPnt = halfRnge + servo0LL;
      switch (phase) {
        case 0: // 1st half-cycle
          zF = midPnt + (halfRnge * sinAmp); break;
        case 1: // 2nd half cycle
          zF = midPnt - (halfRnge * sinAmp); break;
      } anyVal = int(zF);
      if (sine0 == 2) {
        msgTx = "SN0.SX" + str(anyVal) + ".";
        if (abs(servo0Val - anyVal) < 20) {sine0 = 1;}
      } else {msgTx = "SN0.SV" + str(anyVal) + ".";}
      break;
    case 1:
      halfRnge = ((servo1UL) - servo1LL)/2.0; midPnt = halfRnge + servo1LL;
      switch (phase) {
        case 0: // 1st half-cycle
          zF = midPnt + (halfRnge * sinAmp); break;
        case 1: // 2nd half cycle
          zF = midPnt - (halfRnge * sinAmp); break;
      } anyVal = int(zF);
      if (sine1 == 2) {
        msgTx = "SN1.SX" + str(anyVal) + ".";
        if (abs(servo1Val - anyVal) < 20) {sine1 = 1;}
      } else {msgTx = "SN1.SV" + str(anyVal) + ".";}
      break;
    case 2:
      halfRnge = ((servo2UL) - servo2LL)/2.0; midPnt = halfRnge + servo2LL;
      switch (phase) {
        case 0: // 1st half-cycle
          zF = midPnt + (halfRnge * sinAmp); break;
        case 1: // 2nd half cycle
          zF = midPnt - (halfRnge * sinAmp); break;
      } anyVal = int(zF);
      if (sine2 == 2) {
        msgTx = "SN2.SX" + str(anyVal) + ".";
        if (abs(servo2Val - anyVal) < 20) {sine2 = 1;}
      } else {msgTx = "SN2.SV" + str(anyVal) + ".";}
      break;
    case 3:
      halfRnge = ((servo3UL) - servo3LL)/2.0; midPnt = halfRnge + servo3LL;
      switch (phase) {
        case 0: // 1st half-cycle
          zF = midPnt + (halfRnge * sinAmp); break;
        case 1: // 2nd half cycle
          zF = midPnt - (halfRnge * sinAmp); break;
      } anyVal = int(zF);
      if (sine3 == 2) {
        msgTx = "SN3.SX" + str(anyVal) + ".";
        if (abs(servo3Val - anyVal) < 20) {sine3 = 1;}
      } else {msgTx = "SN3.SV" + str(anyVal) + ".";}
      break;
  } usbPortWrite(msgTx); drawFlag = 1;
}

// ----------------------------------------------------------------------

void set0ULValDwn() {
  // reduce the slider upper limit
  servo0UL = servo0UL - valInc;
  if (servo0UL < servo0LL) {servo0LL = servo0UL;}
  servo0LL = max(servo0LL, servoMin);
  servo0UL = max(servo0UL, servoMin);
  send0UL();
}

// ----------------------------------------------------------------------

void set0ULToVal() {
  // sets the upper limit of servo 0 to its current value
  servo0UL = servo0Val;
  send0UL();
}

// ----------------------------------------------------------------------

void set1ULToVal() {
  // sets the upper limit of servo 1 to its current value
  servo1UL = servo1Val;
  send1UL();
}

// ----------------------------------------------------------------------

void set2ULToVal() {
  // sets the upper limit of servo 2 to its current value
  servo2UL = servo2Val;
  send2UL();
}

// ----------------------------------------------------------------------

void set3ULToVal() {
  // sets the upper limit of servo 3 to its current value
  servo3UL = servo3Val;
  send3UL();
}

// ----------------------------------------------------------------------

void set1ULValDwn() {
  // reduce the slider upper limit
  servo1UL = servo1UL - valInc;
  if (servo1UL < servo1LL) {servo1LL = servo1UL;}
  servo1LL = max(servo1LL, servoMin);
  servo1UL = max(servo1UL, servoMin);
  send1UL();
}

// ----------------------------------------------------------------------

void set2ULValDwn() {
  // reduce the slider upper limit
  servo2UL = servo2UL - valInc;
  if (servo2UL < servo2LL) {servo2LL = servo2UL;}
  servo2LL = max(servo2LL, servoMin);
  servo2UL = max(servo2UL, servoMin);
  send2UL();
}

// ----------------------------------------------------------------------

void set3ULValDwn() {
  // reduce the slider upper limit
  servo3UL = servo3UL - valInc;
  if (servo3UL < servo3LL) {servo3LL = servo3UL;}
  servo3LL = max(servo3LL, servoMin);
  servo3UL = max(servo3UL, servoMin);
  send3UL();
}

// ----------------------------------------------------------------------

void set0ULValUp() {
  // increase the slider upper limit
    servo0UL = servo0UL + valInc;
    servo0UL = min(servoMax,servo0UL);
    send0UL();
}

// ----------------------------------------------------------------------

void set1ULValUp() {
  // increase the slider upper limit
    servo1UL = servo1UL + valInc;
    servo1UL = min(servoMax,servo1UL);
    send1UL();
}

// ----------------------------------------------------------------------

void set2ULValUp() {
  // increase the slider upper limit
    servo2UL = servo2UL + valInc;
    servo2UL = min(servoMax,servo2UL);
    send2UL();
}

// ----------------------------------------------------------------------

void set3ULValUp() {
  // increase the slider upper limit
    servo3UL = servo3UL + valInc;
    servo3UL = min(servoMax,servo3UL);
    send3UL();
}

//-------------------------------------------------------------------------

void ToggleDither(int zS) {
  // toggles the respective servo dither ON/OFF if servos are enabled
  if (servoON > 0) {
    switch (zS) {
      case 0:
        if (dither0 == 1) {dither0 = 3;} // set auto-stop
        if (dither0 == 0) {dither0 = 2;} // set auto-start
        sine0 = 0; break;
      case 1:
        if (dither1 == 1) {dither1 = 3;} // set auto-stop
        if (dither1 == 0) {dither1 = 2;} // set auto-start
        sine1 = 0; break;
      case 2:
        if (dither2 == 1) {dither2 = 3;} // set auto-stop
        if (dither2 == 0) {dither2 = 2;} // set auto-start
        sine2 = 0; break;
      case 3:
        if (dither3 == 1) {dither3 = 3;} // set auto-stop
        if (dither3 == 0) {dither3 = 2;} // set auto-start
        sine3 = 0; break;
    }
  } drawFlag = 1;
}

//-------------------------------------------------------------------------

void toggleMouseON() {
  // toggle mouse ON/OFF flag
  if (mON > 0) {
    mON = 0;
  } else {
    mON = 1;
  } drawFlag = 1;
}

//-------------------------------------------------------------------------

void ToggleSine(int zS) {
  // toggles the respective servo sineN ON/OFF if servos are enabled
  if (servoON > 0) {
    switch (zS) {
      case 0:
        if (sine0 > 0) {sine0 = 0;} else {sine0 = 2;}
        dither0 = 0; break;
      case 1:
        if (sine1 > 0) {sine1 = 0;} else {sine1 = 2;}
        dither1 = 0; break;
      case 2:
        if (sine2 > 0) {sine2 = 0;} else {sine2 = 2;}
        dither2 = 0; break;
      case 3:
        if (sine3 > 0) {sine3 = 0;} else {sine3 = 2;}
        dither3 = 0; break;
    }
  } drawFlag = 1;
}

// ----------------------------------------------------------------------

void usbPortWrite(String zmsg) {
  // called to send text over the serial port
  if (comFlag > 0) {usbPort.write(zmsg);}
}
// ----------------------------------------------------------------------
