
// ---------------------------------------------------------------------------------

void MoveToFloor() {
  // called to move the robot to the floor position, turn servos OFF
  if (SubDel > 0) {SubDel--; return;} // skip task if SubDel > 0
  
  switch (SubTask) {
    case 0: // initialise
      servoTgt[0] = Floor0; servoTgt[1] = Floor1;
      servoTgt[2] = Floor2; servoTgt[3] = Floor3;
      moveCalc = true; moveCnt = 100;
      SubTask++; break;
    case 1: //for movement to complete
      if ((moveCnt < 1) && !ValChg) {SubDel = 10; SubTask++;}
      break;
    case 2: // after 200ms delay power off
      Set_MainTask(0); detachServos();
      break;
  }
}

// ---------------------------------------------------------------------------------

void MoveToHome(int zS0,int zS3) {
  // called to move the robot to the Home position, keep servos ON
  // zS0 determines the turntables position
  // zS3 determines the claw grip position
  switch (SubTask) {
    case 0: // initialise
      servoTgt[0] = zS0; servoTgt[1] = Home1;
      servoTgt[2] = Home2; servoTgt[3] = zS3;
      moveCalc = true; moveCnt = 100;
      SubTask++; break;
    case 1: //for movement to complete
      if ((moveCnt < 1) && !ValChg) {Set_MainTask(0);}
      break;
  }
}

// ---------------------------------------------------------------------------------

void MoveToRest() {
  // called to move the robot to the rest position, turn servos OFF
  if (SubDel > 0) {SubDel--; return;} // skip task if SubDel > 0
  
  switch (SubTask) {
    case 0: // initialise
      servoTgt[0] = Reset0; servoTgt[1] = Reset1;
      servoTgt[2] = Reset2; servoTgt[3] = Reset3;
      moveCalc = true; moveCnt = 100;
      SubTask++; break;
    case 1: //for movement to complete
      if ((moveCnt < 1) && !ValChg) {SubDel = 10; SubTask++;}
      break;
    case 2: // after 200ms delay power off
      Set_MainTask(0); detachServos();
      break;
  }
}

// ---------------------------------------------------------------------------------
